/*******************************************************************************
Copyright (C) 2008 HIMACS,ltd.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
   See the License for the specific language governing permissions and limitations under the License.

This Software (including binary module, source code, other additional module)(gSoftwareh)
is provided and licensed by HIMACS, Ltd. (gHIMACSh) on an as is basis and free of charge.
HIMACS disclaims any express or implied warranties, including, but not limited to,
the bug-free and defect-free programming, this Softwarefs perfect running under the recommended
environment for its usage, the implied warranties of merchantability and fitness
for a particular purpose with regard to this Software. HIMACS shall not be responsible for 
all liability for any loss, liability, damages (whether direct or indirect,
incidental or consequential, and including loss of data or profits,
or damages caused by business interruption),
personal injury or expense of any nature whatsoever which may be suffered
by the user of this Software as a result of or which may be attributable, directly or indirectly,
to the use of this Software.
*******************************************************************************/
/**
 * Created on 9 sept. 2008
 * Created by Takaki Tsue, Masato Kawahashi
 * Copyright (C) 2008 HIMACS,ltd. 
 * Licensed under the Apache License, Version 2.0
 *
 */

#ifndef __TEST_MALLOC_WITH_GERONS
#define __TEST_MALLOC_WITH_GERONS

/* Constants to be defined , please fix me */
#define SHM_KEY		5000
#define MAX_ENTRY	(1024 * 512)
#define STACK_DEPTH	10
#define MAX_STRLEN	256

/* definition of log entry */
typedef struct {
#define TYPE_MALLOC	1
#define TYPE_FREE	2
	pid_t	pid;
	short 	type;
	size_t	size;
	void *ptr;
	void *stack[STACK_DEPTH];
	char address[STACK_DEPTH][MAX_STRLEN + 1];
} SHM_LOG;

/* definition of layout on shared memory */
typedef struct {
	unsigned long nEntry; // total line number
	unsigned long curPos; // current position to be logged
	SHM_LOG	log[1];
} GERONS_SHM;

#endif /* __TEST_MALLOC_WITH_GERONS */
